<?php
class Search extends CI_Controller {


    public function __construct()
    {
        parent::__construct();
        $this->load->model('Academic_Map');
        $this->load->library('session');
        $this->load->helper('url');
    }

    public function index()
    {
        $this->load->view('index');
    }

    public function multi_author_page($author_name,$page=1)
    {
        $data['inform'] = $this->Academic_Map->get_Multi_Author_Data($author_name,$page);
        $data_pag['inform'] = array("Key"=>$author_name,
                                    "Current_Page"=>$page,
                                    "Total_Page"=>$data["inform"]["Total"],
                                    "Call"=>"multi_author_request");
        $this->load->view('header');
        $this->load->view('result', $data);
        $this->load->view('pagination',$data_pag);
        $this->load->view('footer');
    }

    public function single_author_page($author_ID,$page=1)
    {
        $data['inform'] = $this->Academic_Map->get_Single_Author_Data($author_ID,$page);
        $data_pag['inform'] = array("Key"=>$author_ID,
                                    "Current_Page"=>$page,
                                    "Total_Page"=>$this->Academic_Map->get_Single_Page_Num($author_ID),
                                    "Call"=>"single_author_request");
        $data_graph['inform'] = array("Author_ID"=>$author_ID);
        $this->load->view('header');
        $this->load->view('author',$data);
        $this->load->view('pagination',$data_pag);
        $this->load->view('force_directed_graph',$data_graph);
        $this->load->view('footer');
    }

    public function multi_paper_page($title,$page=1)
    {
        $data['inform'] = $this->Academic_Map->get_Multi_Paper_Data($title,$page);
        $data_pag['inform'] = array("Key"=>$title,
                                    "Current_Page"=>$page,
                                    "Total_Page"=>$data["inform"]["Total"],
                                    "Call"=>"multi_paper_request");
        $this->load->view('header');
        $this->load->view('paper_result',$data);
        $this->load->view('pagination',$data_pag);
        $this->load->view('footer');
    }

    public function conference_page($conference,$page=1)
    {
        $data['inform'] = $this->Academic_Map->get_Conference_Data($conference,$page);
        $data_pag['inform'] = array("Key"=>$conference,
                                    "Current_Page"=>$page,
                                    "Total_Page"=>$data["inform"]["Total"],
                                    "Call"=>"conference_request");
        $this->load->view('header');
        $this->load->view('paper_result',$data);
        $this->load->view('pagination',$data_pag);
        $this->load->view('footer');
    }

    public function keyword_page($keyword_ID,$page=1)
    {
        $data['inform'] = $this->Academic_Map->get_Keyword_Data($keyword_ID,$this->session->id);
        $data_pag['inform'] = array("Key"=>$keyword_ID,
                                    "Current_Page"=>$page,
                                    "Total_Page"=>$this->Academic_Map->get_Keyword_Page_Num($keyword_ID),
                                    "Call"=>"keyword_request");
        $this->load->view('header');
        $this->load->view('keyword',$data);
        $this->load->view('pagination',$data_pag);
        $this->load->view('footer');
    }

    public function paper_page($paper_ID)
    {
        $data['inform'] = $this->Academic_Map->get_Paper_Page($paper_ID);
        $this->load->view('header');
        $this->load->view('paper',$data);
        $this->load->view('footer');
    }

    public function paper_post() //from the nav
    {
        $title = $this->input->post('key');
        if (!$title) show_404();
        else $this->multi_paper_page($title);
    }

    public function conference_post()
    {
        $conference = $this->input->post('key');
        if (!$conference) show_404();
        else $this->conference_page($conference);
    }

    public function paper_ID_post() //from the nav
    {
        $paper_ID = $this->input->post('key');
        if (!$paper_ID) show_404();
        else $this->paper_page($paper_ID);
    }

    public function author_ID_post()  //from the nav
    {
        $author_ID = $this->input->post('key');
        if (!$author_ID) show_404();
        else $this->single_author_page($author_ID);
    }

    public function author_post()  //from the nav
    {
        $author_name = $this->input->post('key');
        if (!$author_name) show_404();
        else $this->multi_author_page($author_name);
    }

    public function author_request()  //from ajax
    {
        $paper_ID = $this->input->post('Paper_ID');
        $data = $this->Academic_Map->get_Paper_Author($paper_ID);
        echo json_encode($data);
    }

    public function multi_author_request()
    {
        $author_name = $this->input->post('Author_Name');
        $page = $this->input->post('Page');
        $data = $this->Academic_Map->get_Multi_Author_Data($author_name,$page);
        echo json_encode($data);
    }

    public function single_author_request()
    {
        $author_ID = $this->input->post('Author_ID');
        $page = $this->input->post('Page');
        $data = $this->Academic_Map->get_Single_Author_Data($author_ID,$page);
        echo json_encode($data);
    }

    public function keyword_request()
    {
        $keyword_ID = $this->input->post('Keyword_ID');
        $page = $this->input->post('Page');
        $data = $this->Academic_Map->get_Keyword_Paper($keyword_ID,$page);
        echo json_encode($data);
    }

    public function multi_paper_request()
    {
        $title = $this->input->post('Title');
        $page = $this->input->post('Page');
        $data = $this->Academic_Map->get_Multi_Paper_Data($title,$page);
        echo json_encode($data);
    }

    public function conference_request()
    {
        $conference = $this->input->post('Conference');
        $page = $this->input->post('Page');
        $data = $this->Academic_Map->get_Conference_Data($conference,$page);
        echo json_encode($data);
    }

    public function force_directed_graph($author_ID)
    {
        $graph_data = $this->Academic_Map->get_Graph_Data($author_ID);
        echo json_encode($graph_data);
    }

    public function student_graph($author_ID)
    {
        $graph_data = $this->Academic_Map->get_Student_Graph_Data($author_ID);
        echo json_encode($graph_data);
    }

    public function force_directed_graph2($author_ID)
    {
        $graph_data = $this->Academic_Map->get_Graph_Data($author_ID);
        echo json_encode($graph_data);
    }

    public function author_auto_complete()
    {
        $term = $this->input->get('term');
        $data = $this->Academic_Map->get_author_auto_complete($term);
        echo json_encode($data,true);
    }

    public function paper_auto_complete()
    {
        $term = $this->input->get('term');
        $data = $this->Academic_Map->get_paper_auto_complete($term);
        echo json_encode($data,true);
    }

    public function pass()
    {
        echo json_encode([],true);
    }

    public function login()
    {
        $name = $this->input->post('name');
        $password = $this->input->post('password');
        $data = $this->Academic_Map->login($name,$password);
        if ($data["method"]=="login"&&$data["result"]=="succeed")
        {
            $this->session->logined=1;
            $this->session->user=$name;
            $this->session->id=$data['id'];
        }
        if ($data["method"]=="signup")
        {
            $this->session->signuser=$name;
            $this->session->signid=$data['id'];
        }
        echo json_encode($data);
    }

    public function signup()
    {
        $this->session->logined=1;
        $this->session->user=$this->session->signuser;
        $this->session->id=$this->session->signid;
        $choice = $this->input->post('checkbox');
        $LevelArray=array(0=>$choice,1=>array(),2=>array(),-1=>array());
        $this->Academic_Map->LevelArrayEdit($this->session->id,$LevelArray,2);
        redirect("");
    }

    public function logout()
    {
        $this->session->logined=0;
        $this->session->user="";
        $this->session->id=-1;
        echo json_encode(["ss"=>"ss"]);
    }

    public function good()
    {
        $keywordid=$this->input->post('keywordid');
        $this->Academic_Map->KeywordsArrayEdit($this->session->id,array($keywordid),2);
    }

    public function bad()
    {
        $keywordid=$this->input->post('keywordid');
        $this->Academic_Map->KeywordsArrayEdit($this->session->id,array($keywordid),-1);
    }
}?>