<?php
class Academic_Map extends CI_Model {

    public $inform_per_page=10;

    public function __construct()
    {
        parent::__construct();
        $this->load->database();
    }

    /*public function get_Multi_Author_Data($author_name,$page)
    {
        $start = ($page-1) * $this->inform_per_page;
        $sql = "SELECT a.Author_ID,a.Author_Name,count(b.Paper_ID) AS NUM FROM authors a,paper_author_affiliation b WHERE  a.Author_Name LIKE '%{$this->db->escape_like_str($author_name)}%' AND b.Author_ID=a.Author_ID GROUP BY a.Author_ID ORDER BY NUM DESC LIMIT $start,10";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        for ($i = 0; $i < sizeof($result); $i++)
        {
            $current_author_ID = $result[$i]['Author_ID'];
            $result[$i]['Affiliation_Name'] = $this->get_Affiliation_Name($this->get_Author_Major($current_author_ID));
        }
        $result['Total_Page'] = $this->get_Multi_Page_Num($author_name);
        $result['Current_Page'] = $page;
        $result['Author_Name'] = $author_name;


        return $result;
    }*/

    public function get_Multi_Author_Data($author_name,$page)
    {
        $client = Elasticsearch\ClientBuilder::create()->setHosts(['localhost:9200'])->build();
        $start = ($page-1) * $this->inform_per_page;
        $query = [
        "index" => "authors",
        "type" => "author",
        "body" => [
                "query" => ["match" => ["name"=>["query"=>$author_name,"fuzziness"=>"Auto"]]],
                "sort" => ["paper_num"=>["order"=>"desc"]],
                "size" => $start+ $this->inform_per_page
            ]
        ];
        $resp = $client->search($query);
        $result = [];
        $result["Total"] =  ceil($resp["hits"]["total"]/ $this->inform_per_page);
        for ($i = 0; $i < min( $this->inform_per_page,$resp["hits"]["total"]-$start);$i++)
        {
            $index=$resp["hits"]["hits"][$i+$start]["_source"];
            $result[$i]["Author_ID"]=$index["author_id"];
            $result[$i]["Author_Name"]=$index["name"];
            $result[$i]["NUM"]=$index["paper_num"];
            $result[$i]["Affiliation_Name"]= $this->get_Affiliation_Name($this->get_Author_Major($index["author_id"]));            
        }
        return $result;
    }

    public function get_Single_Author_Data($author_ID,$page)
    {
        $name = $this->get_Author_Name($author_ID);
        $start = ($page-1) * $this->inform_per_page;
        $sql = "SELECT a.Paper_ID,a.Affiliation_ID,b.Cite AS NUM FROM paper_author_affiliation a, papers b WHERE a.Author_ID='{$author_ID}' AND a.Paper_ID=b.Paper_ID ORDER BY b.Cite DESC LIMIT $start,10";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        for ($i = 0; $i < sizeof($result); $i++)
        {
            $current_Paper_ID = $result[$i]['Paper_ID'];
            $result[$i]['Title'] = $this->get_Paper_Title($current_Paper_ID);
            $result[$i]['Venue'] = $this->get_Conference_Name($current_Paper_ID);
            $result[$i]['Affiliation_Name'] = $this->get_Affiliation_Name($result[$i]['Affiliation_ID']);
        }
        $result['Author_ID'] = $author_ID;
        $result['Author_Name'] = $name;
        return $result;
    }

    public function get_Multi_Paper_Data($title,$page)
    {
        $client = Elasticsearch\ClientBuilder::create()->setHosts(['localhost:9200'])->build();
        $start = ($page-1) * $this->inform_per_page;
        $query = [
        "index" => "papers",
        "type" => "paper",
        "body" => [
                "query" => ["match_phrase" => ["title"=>["query"=>$title,"slop"=>"3"]]],
                "sort" => ["cite"=>["order"=>"desc"]],
                "size" => $start+ $this->inform_per_page
            ]
        ];
        $resp = $client->search($query);
        $result = [];
        $result["Total"] =  ceil($resp["hits"]["total"]/ $this->inform_per_page);
        for ($i = 0; $i < min( $this->inform_per_page,$resp["hits"]["total"]-$start);$i++)
        {
            $index=$resp["hits"]["hits"][$i+$start]["_source"];
            $result[$i]["Paper_ID"]=$index["paper_id"];
            $result[$i]["Title"]=$index["title"];
            $result[$i]["Paper_Publish_Year"]=$index["paper_publish_year"];
            $result[$i]["Cite"]=$index["cite"];
            $result[$i]["Conference"]= $index["conference"];            
        }
        return $result;
    }

    public function get_Conference_Data($conference,$page)
    {
        $client = Elasticsearch\ClientBuilder::create()->setHosts(['localhost:9200'])->build();
        $start = ($page-1) * 10;
        $query = [
        "index" => "papers",
        "type" => "paper",
        "body" => [
                "query" => ["match" => ["conference"=>$conference]],
                "sort" => ["cite"=>["order"=>"desc"]],
                "size" => $start+10
            ]
        ];
        $resp = $client->search($query);
        $result = [];
        $result["Total"] =  ceil($resp["hits"]["total"]/10);
        for ($i = 0; $i < min(10,$resp["hits"]["total"]-$start);$i++)
        {
            $index=$resp["hits"]["hits"][$i+$start]["_source"];
            $result[$i]["Paper_ID"]=$index["paper_id"];
            $result[$i]["Title"]=$index["title"];
            $result[$i]["Paper_Publish_Year"]=$index["paper_publish_year"];
            $result[$i]["Cite"]=$index["cite"];
            $result[$i]["Conference"]= $index["conference"];            
        }
        return $result;
    }
    
    public function get_Keyword_Paper($keyword_ID,$page)
    {
        $start = ($page-1) * $this->inform_per_page;
        $sql = "SELECT Paper_ID,Title,Cite FROM papers WHERE Keyword_ID='{$keyword_ID}' ORDER BY Cite DESC LIMIT $start,10";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        return $result;
    }

    public function get_Keyword_Page_Num($keyword_ID)
    {
        $sql = "SELECT Paper_ID FROM papers WHERE Keyword_ID='{$keyword_ID}'";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        return count($result);
    }


    public function get_Keyword_Data($keyword_ID,$user_ID=NULL)
    {
        $name = $this->Keyword($keyword_ID);
        $parenttmp=$this->Parent($keyword_ID);
        $result["keyword"]=$name;
        $result["keywordid"]=$keyword_ID;
        $result["keywords"]=array($keyword_ID);
        foreach($parenttmp as $p){
            $pname=$this->Keyword($p);
            $result["Parent"][]=array("name"=>$pname,"id"=>$p);
            array_push($result["keywords"],$p);
        }
        $childrentmp=$this->Child($keyword_ID);
        foreach($childrentmp as $c){
            $cname=$this->Keyword($c);
            $result["Children"][]=array("name"=>$cname,"id"=>$c);
            array_push($result["keywords"],$c);
        }
        if ($user_ID) $this->KeywordsArrayEdit($user_ID,$result["keywords"],2);
        $PaperIDtmp=$this->get_Keyword_Paper($keyword_ID,1);
        foreach($PaperIDtmp as $paper){
            $result["Papers"][]=array("Paper_ID"=>$paper["Paper_ID"],"Title"=>$paper["Title"],"Cite"=>$paper["Cite"]);
        }
        $similarones=$this->similarones($user_ID);
        for($i=0;$i<5;$i++){
            $recuser_ID=$similarones[$i];
            $result["Recusers"][]=array("name"=>$this->name($recuser_ID),"id"=>$recuser_ID);
        }
        $likes=$this->HisMostKeywords($user_ID);
        $otherlikes=$this->HisMostKeywords($similarones[0]);
        foreach($otherlikes as $onelike){
            if(!in_array($onelike,$likes)){
                $result["Like"][]=array("id"=>$onelike,"name"=>$this->Keyword($onelike));
            }
        }
        return $result;
    }


    public function get_Multi_Page_Num($author_name)
    {
        $sql = "SELECT Author_ID,Author_Name FROM authors WHERE Author_Name LIKE '%{$this->db->escape_like_str($author_name)}%'";
        $query = $this->db->query($sql);
        return ceil($query->num_rows()/$this->inform_per_page);
    }

    public function get_Single_Page_Num($author_ID)
    {
        $query = $this->db->select("Paper_ID")->from("paper_author_affiliation")->where("Author_ID",$author_ID)->get();
        return ceil($query->num_rows()/$this->inform_per_page);
    }

    public function get_Paper_Page($paper_ID)
    {
        $sql = "SELECT Title,Paper_Publish_Year FROM papers WHERE Paper_ID='$paper_ID'";
        $query = $this->db->query($sql);
        $result = $query->row_array();
        $result['Venue'] = $this->get_Conference_Name($paper_ID);
        $result['Author'] = $this->get_Paper_Author($paper_ID);
        $result['Keyword_ID'] = $this->KeywordID($paper_ID);
        
        if ($result['Keyword_ID']) $result['Keyword']=$this->Keyword($result['Keyword_ID']);
        $sql1 = "SELECT Paper_ID FROM paper_reference where Reference_ID='{$paper_ID}'";
        $result1 = $this->db->query($sql1);
        $HisRelated=array();
        while($x=$result1->unbuffered_row()){
            array_push($HisRelated,$x->Paper_ID);
        };
        $sql2 = "SELECT Reference_ID FROM paper_reference where Paper_ID='{$paper_ID}'";
        $result2 = $this->db->query($sql2);
        while($x=$result2->unbuffered_row()){
            array_push($HisRelated,$x->Reference_ID);
        };
        $return=array();
        foreach ($HisRelated as $one){
            $sql3 = "SELECT Cite,Title FROM papers where Paper_ID='{$one}'";
            $result3 = $this->db->query($sql3);
            $x=$result3->row_array();
            array_push($return,array('Paper_ID'=>$one,'Cite'=>$x['Cite'],'Title'=>$x['Title']));
        }
        if(count($return)>3)
        {
            $FinalRec=array();
            while(count($FinalRec)<3){
                $OneBasicRecom=$this->OneBasicRecom($return);
                if(! in_array($OneBasicRecom,$FinalRec)){
                    array_push($FinalRec,$OneBasicRecom);
                }
                }
        }
        else $FinalRec=$return;
        $result["Rec"]=$FinalRec;
        return $result;
    }

    public function get_Paper_Author($paper_ID)
    {
        $sql = "SELECT a.Author_ID,a.Author_Name,b.Author_Sequence FROM authors a,paper_author_affiliation b WHERE b.Paper_ID='$paper_ID' AND a.Author_ID=b.Author_ID ORDER BY b.Author_Sequence";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        return $result;
    }

    public function get_Author_Auto_Complete($term)
    {
        $client = Elasticsearch\ClientBuilder::create()->setHosts(['localhost:9200'])->build();
        $query = [
            "index" => "authors",
            "type" => "author",
            "body" => [
                    "query" => ["match" => ["name"=>["query"=>$term,"fuzziness"=>"Auto"]]],
                    "sort" => ["paper_num"=>["order"=>"desc"]],
                    "size" => 10
                ]
        ];
        $resp = $client->search($query);
        for ($i = 0; $i < count($resp["hits"]["hits"]);$i++)
        {
            $index=$resp["hits"]["hits"][$i]["_source"];
            $result[]=$index["name"];          
        }
        return $result;
    }

    public function get_Paper_Auto_Complete($term)
    {
        $client = Elasticsearch\ClientBuilder::create()->setHosts(['localhost:9200'])->build();
        $query = [
        "index" => "papers",
        "type" => "paper",
        "body" => [
                "query" => ["match_phrase" => ["title"=>["query"=>$term,"slop"=>"3"]]],
                "sort" => ["cite"=>["order"=>"desc"]],
                "size" => 10
            ]
        ];
        $resp = $client->search($query);
        for ($i = 0; $i < count($resp["hits"]["hits"]);$i++)
        {
            $index=$resp["hits"]["hits"][$i]["_source"];
            $result[]=$index["title"];          
        }
        return $result;
    }

    private function get_Author_Name($author_ID)
    {
        $query = $this->db->select()->from("authors")->where("Author_ID",$author_ID)->get();
        $result = $query->row_array();
        return $result['Author_Name'];
    }

    private function get_Affiliation_Name($affiliation_ID)
    {
        $query = $this->db->select("Affiliation_Name")->from("affiliations")->where("Affiliation_ID",$affiliation_ID)->get();
        $result = $query->row_array();
        return $result['Affiliation_Name'];
    }

    private function get_Conference_Name($paper_ID)
    {
        $this->conference_ID = $this->input->get("Conference_ID");
        $sql = "SELECT a.Conference_Name FROM conferences a,papers b WHERE b.Paper_ID='{$paper_ID}' AND a.Conference_ID=b.Conference_ID";
        $query = $this->db->query($sql);
        $result = $query->row_array();
        return $result['Conference_Name'];
    }

    private function get_Author_Major($author_ID)
    {
        $sql = "SELECT Affiliation_ID,COUNT(*) as NUM FROM paper_author_affiliation WHERE Author_ID=".$this->db->escape($author_ID)." AND Affiliation_ID!='None' GROUP BY Affiliation_ID ORDER BY NUM DESC LIMIT 1";
        $query = $this->db->query($sql);
        $result = $query->row_array();
        return $result['Affiliation_ID'];
    }

    private function get_Paper_Title($paper_ID)
    {
        $query = $this->db->select("Title")->from("papers")->where("Paper_ID",$paper_ID)->get();
        $result = $query->row_array();
        return $result['Title'];
    }

    public function get_Graph_Data($author_ID)
    {
        $final = array("nodes"=>array(),"links"=>array());
        $final["nodes"][0]=array("id"=>$author_ID,"group"=>0);
        $sql = "SELECT c.Author_Name,a.Author_ID,COUNT(a.Author_ID) as NUM FROM paper_author_affiliation a,(SELECT Paper_ID FROM paper_author_affiliation WHERE Author_ID=".$this->db->escape($author_ID).") b,authors c WHERE a.Paper_ID=b.Paper_ID AND a.Author_ID=c.Author_ID GROUP BY a.Author_ID";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        $totalnode = 0;
        $totallink = 0;
        foreach ($result as $row)
        {
            if ($row["Author_ID"]==$author_ID)
            {
                $final["nodes"][0]["name"]=$row["Author_Name"];
            }
            else
            {
                $final["nodes"][++$totalnode]=array("id"=>$row["Author_ID"],"group"=>intval($row["NUM"]),"name"=>$row["Author_Name"]);
                $final["links"][$totallink++]=array("source"=>$author_ID,"target"=>$row["Author_ID"],"value"=>intval($row["NUM"]));
                $tempsql = "SELECT Author_ID,COUNT(a.Author_ID) as NUM FROM paper_author_affiliation a,(SELECT Paper_ID FROM paper_author_affiliation WHERE Author_ID=".$this->db->escape($row["Author_ID"]).") b WHERE a.Paper_ID=b.Paper_ID GROUP BY a.Author_ID";
                $tempquery = $this->db->query($tempsql);
                $tempresult = $tempquery->result_array();
                $templinks=array();
                foreach ($tempresult as $temprow) {$templinks[$temprow["Author_ID"]]=$temprow["NUM"];}
                for ($i=1;$i<sizeof($final["nodes"])-1;$i++)
                {
                    if (isset($templinks[$final["nodes"][$i]["id"]]))
                        $final["links"][$totallink++]=array("source"=>$row["Author_ID"],"target"=>$final["nodes"][$i]["id"],"value"=>intval($templinks[$final["nodes"][$i]["id"]]));
                }

            }
        }
        return $final;
    }

    public function get_Student_Graph_Data($author_ID)
    {
        $sql1="SELECT Author_Name,Author_ID FROM authors WHERE Author_ID=";
        $query = $this->db->query($sql1."'{$author_ID}'");
        $result=$query->unbuffered_row();
        $name=$result->Author_Name;
        $id=$result->Author_ID;
        $sql2="SELECT Student, b.Author_Name FROM relationship a LEFT JOIN Authors b ON a.Student=b.Author_ID WHERE Teacher =";
        $query=$this->db->query($sql2."'{$author_ID}'");
        $result=$query->unbuffered_row();
        //data { {"name"  "parent"=>""} }
        $data=array(array("name"=>$id,"title"=>$name,"parent"=>null));
        $box=array();
        $in=array($name);
        $i=0;
        while($result)
        {
            $i++;
            if($result->Student==$author_ID){
                $result=$query->unbuffered_row();
                continue;
            }
            $data[]=array("name"=>$result->Student,"parent"=>$id, "title"=>$result->Author_Name);
            $box[$result->Student]=$result->Author_Name;
            $in[]=$result->Author_Name;
            $result=$query->unbuffered_row();
            if ($i>10) break;
        }

        $layer=0;
        while(sizeof($box))
        {
            if($layer>=3)break;
            $newbox=array();
            foreach ($box as $id => $item )
            {
                $query=$this->db->query($sql2."'{$id}'");
                $result=$query->unbuffered_row();
                $i=0;
                while($result){
                    $i++;
                    if(in_array($result->Author_Name,$in))
                    {
                        $result=$query->unbuffered_row();
                        continue;
                    }
                    $new=array("name"=>$result->Student,"parent"=>$id, "title"=>$result->Author_Name);
                    $data[]=$new;
                    $in[]=$result->Author_Name;
                    $newbox[$result->Student]=$result->Author_Name;
                    $result=$query->unbuffered_row();
                    if ($i>10) break;
                }
            }

            $box=$newbox;
            $layer++;
        }
        return $data;
    }
    public function login($name,$password)
    {
        $sql0="SELECT COUNT(*) AS NUM FROM user";
        $query = $this->db->query($sql0);
        $result = $query->result_array();
        $num = $result[0]["NUM"];
        $sql = "select * from user where username='$name'";
        $query = $this->db->query($sql);
        $result = $query->result_array();
        if (count($result)==0) 
        {
            $return["method"] = "signup";
            $return["name"] = $name;
            $return["id"] = $num+1;
            $str0="0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0";
            $str1="0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0";
            $str2="0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0";
            $striso="0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0";
            $sql2="insert into user(id,username,password,Level0,Level1,Level2,Leveliso) values ($num+1,'$name','$password','$str0','$str1','$str2','$striso')";
            $query = $this->db->query($sql2);
        }
        else
        {
            $return["method"] = "login";
            $return["name"] = $name;
            $return["id"] = $result[0]["id"];
            if ($result[0]["password"]!=$password) $return["result"]="fail";
            else $return["result"]="succeed";
        }
        return $return;
    }

public function root($B)//获得某论文的所有根话题；B是一个PaperID
{
    $roots=array();
    $sql="SELECT Parent FROM keyword_matrix WHERE Child='{$B}'";
    $result = $this->db->query($sql);
    $count=0;
    while ($x=$result->unbuffered_row()){
        foreach (root($x->Parent) as $j) {
            if (!in_array($j, $roots)) {
                array_push($roots, $j);
            }
        }
        $count++;
    }
    if ($count==0) array_push($roots,$B);
    return $roots;
}

public function KeywordID($PaperID){//返回一个论文的自身的KeywordID，若没有，返回NULL
    $sql="SELECT Keyword_ID FROM papers WHERE Paper_ID='{$PaperID}'";
    $result = $this->db->query($sql);
    $x=$result->row_array();
    if(count($x)==0){
        return NULL;
    }else{
        return $x['Keyword_ID'];
    }

}

public function Papers($KeywordID){//返回论文组
    $sql="SELECT Paper_ID,Title,Cite FROM papers WHERE Keyword_ID='{$KeywordID}'";
    $result = $this->db->query($sql);
    $PaperIDarray=array();
    while($x=$result->unbuffered_row()){
        array_push($PaperIDarray,array($x->Paper_ID,$x->Title,$x->Cite));
    }
    return $PaperIDarray;
}

public function Keyword($KeywordID){//返回一个KeywordID对应的名字
    $sql="SELECT Keyword FROM keywords2 WHERE KeywordID = '{$KeywordID}'";
    $result = $this->db->query($sql);
    $x=$result->row_array();
    return $x['Keyword'];
}

public function Parent($KeywordID){//返回一个Array，其中是某Keyword的所有Parent
    $sql="SELECT Parent FROM keyword_matrix WHERE Child='{$KeywordID}'";
    $result = $this->db->query($sql);
    $Parentlist=array();
    while($x=$result->unbuffered_row()){
        array_push($Parentlist, $x->Parent);
    }
    return $Parentlist;
}

public function Child($KeywordID){//返回一个Array，其中是某Keyword的所有Child，注意，可能很长。如'073B64E4'有583个Child
    $sql="SELECT Child FROM keyword_matrix WHERE Parent='{$KeywordID}'";
    $result = $this->db->query($sql);
    $Childlist=array();
    while($x=$result->unbuffered_row()){
        array_push($Childlist, $x->Child);
    }
    return $Childlist;
}

//$array=Child('073B64E4');


public function LevelArray($KeywordsArray){//传入一个含若干KeywordID的数组，要得到这些KeywordID的Level和LevelNo。传出一个大数组，其中有四个Level数组，每个含对应Level内的LevelNo
    $LevelArray=array(0=>array(),1=>array(),2=>array(),-1=>array());//分别储存Level为0，1，2，-1
    foreach ($KeywordsArray as $KeywordID){
        $sql="SELECT Level,LevelNo FROM keywords2 WHERE KeywordID='{$KeywordID}'";
        $result = $this->db->query($sql);
        $x=$result->row_array();
        //if(count($x)==2){
            $Level=intval($x['Level']);$LevelNo=intval($x['LevelNo']);
        //}
        if ($Level!=3){
            array_push($LevelArray[$Level], $LevelNo);
        }
    }
    return $LevelArray;
}


public function KeywordsArrayEdit($userid,$KeywordsArray,$degree){//修改用户数据的函数。传入三个参数。第一个为userid,int;第二个为KeywordsArray，参照function LevelArray；第三个为修改的程度，正负整数；
    $LevelArray=$this->LevelArray($KeywordsArray);
    $sql="SELECT Level0,Level1,Level2,Leveliso FROM user WHERE id={$userid}";
    $result = $this->db->query($sql);
    $x=$result->row_array();


    $Level0array=explode(',', $x['Level0']);//字符串转数组
    foreach ($LevelArray[0] as $x0){
        $Level0array[$x0]+=$degree;
    }

    $Level1array=explode(',', $x['Level1']);
    foreach ($LevelArray[1] as $x1){
        $Level1array[$x1]+=$degree;
    }

    $Level2array=explode(',', $x['Level2']);
    foreach ($LevelArray[2] as $x2){
        $Level2array[$x2]+=$degree;
    }

    $Levelisoarray=explode(',', $x['Leveliso']);//iso意为isolated，即代数为-1
    foreach ($LevelArray[-1] as $xiso){
        $Levelisoarray[$xiso]+=$degree;
    }


    $newstr0=implode(',',$Level0array);
    $newstr1=implode(',',$Level1array);
    $newstr2=implode(',',$Level2array);
    $newstriso=implode(',',$Levelisoarray);
    $sql="UPDATE user SET Level0='{$newstr0}',Level1='{$newstr1}',Level2='{$newstr2}',Leveliso='{$newstriso}' WHERE id={$userid}";
    $result=$this->db->query($sql);
}
//$KeywordsArray=Child('073B64E4');
//KeywordsArrayEdit(9,$KeywordsArray,1);

public function LevelArrayEdit($userid,$LevelArray,$degree){//功能同上一个，只是传入的数组是LevelArray

    $sql="SELECT Level0,Level1,Level2,Leveliso FROM user WHERE id={$userid}";
    $result = $this->db->query($sql);
    $x=$result->row_array();


    $Level0array=explode(',', $x['Level0']);//字符串转数组
    foreach ($LevelArray[0] as $x0){
        $Level0array[$x0]+=$degree;
    }

    $Level1array=explode(',', $x['Level1']);
    foreach ($LevelArray[1] as $x1){
        $Level1array[$x1]+=$degree;
    }

    $Level2array=explode(',', $x['Level2']);
    foreach ($LevelArray[2] as $x2){
        $Level2array[$x2]+=$degree;
    }

    $Levelisoarray=explode(',', $x['Leveliso']);//iso意为isolated，即代数为-1
    foreach ($LevelArray[-1] as $xiso){
        $Levelisoarray[$xiso]+=$degree;
    }
    $newstr0=implode(',',$Level0array);
    $newstr1=implode(',',$Level1array);
    $newstr2=implode(',',$Level2array);
    $newstriso=implode(',',$Levelisoarray);
    $sql="UPDATE user SET Level0='{$newstr0}',Level1='{$newstr1}',Level2='{$newstr2}',Leveliso='{$newstriso}' WHERE id={$userid}";
    $result=$this->db->query($sql);
}

public function getMod($arr){//传入一个数组，返回其模长
    $strModDouble = 0;
    foreach($arr as $val){
        $strModDouble += $val * $val;
    }
    $strMod = sqrt($strModDouble);
    if($strMod==0){return 1;}//防止除数为0
    return $strMod;
}

public function getCosine($arrMark, $arrAnaly){//标记向量和分析向量
    $Vector = 0;
    for($i = 0; $i < count($arrMark); $i++){
        $MarkVal = intval($arrMark[$i]);
        $AnalyVal = intval($arrAnaly[$i]);
        $Vector += $MarkVal * $AnalyVal;
        $ModProduct=$this->getMod($arrMark)*$this->getMod($arrAnaly);
    }
    $Cosine = $Vector/$ModProduct;
    return $Cosine;
}
public function hisarrays($userid){//返回某人的4个向量
    $sql="SELECT Level0,Level1,Level2,Leveliso FROM user WHERE id={$userid}";
    $result = $this->db->query($sql);
    $x=$result->row_array();
    $LevelArray=array(0=>array(),1=>array(),2=>array(),-1=>array());//分别储存Level为0，1，2，-1
    $Level0array=explode(',', $x['Level0']);
    $Level1array=explode(',', $x['Level1']);
    $Level2array=explode(',', $x['Level2']);
    $Levelisoarray=explode(',', $x['Leveliso']);
    $LevelArray[0]=$Level0array;
    $LevelArray[1]=$Level1array;
    $LevelArray[2]=$Level2array;
    $LevelArray[-1]=$Levelisoarray;
    return $LevelArray;

}

public function similarity($idMark, $idAnaly){//返回某两个人之间的相似度
    $arrayMark=$this->hisarrays($idMark);
    $arrayAnaly=$this->hisarrays($idAnaly);
    $cos=0;
    $cos += 0.4*$this->getCosine($arrayMark[0], $arrayAnaly[0]);//加权
    $cos += 0.2*$this->getCosine($arrayMark[1], $arrayAnaly[1]);
    $cos += 0.1*$this->getCosine($arrayMark[2], $arrayAnaly[2]);
    $cos += 0.3*$this->getCosine($arrayMark[-1], $arrayAnaly[-1]);
    return $cos;
}


public function similarones($userid){//返回一个数组，其中是
    $sql="SELECT COUNT(*) FROM user";
    $result = $this->db->query($sql);
    $x=$result->row_array();
    $max=$x['COUNT(*)'];
    $similarities=array();
    for($i=1;$i<=$max;$i++){
        if($i===$userid){continue;}
        array_push($similarities,array('id'=>$i,'sim'=>$this->similarity($userid,$i)));
    }
    foreach ($similarities as $key => $row)
    {
        $id[$key]  = $row['id'];
        $sim[$key] = $row['sim'];
    }
    array_multisort($sim, SORT_DESC, $similarities);

    $simones=array();
    foreach ($similarities as $simone){
        array_push($simones,$simone['id']);
    }

    return $simones;
}

public function name($userid){
    $sql="SELECT username FROM user WHERE id={$userid}";
    $result = $this->db->query($sql);
    $x= $result->row_array();
    return $x['username'];
}

public function StrToArr($str){//传入MySQL中的字符串，传出对应的排好序的KeywordID
    $arr=explode(',', $str);
    if(count($arr)==96){
        $Level=0;
    }
    if(count($arr)==351){
        $Level=1;
    }
    if(count($arr)==1641){
        $Level=2;
    }
    if(count($arr)==65){
        $Level=-1;
    }
    $sql="SELECT KeywordID FROM keywords2 WHERE Level={$Level} ORDER BY LevelNo ASC";
    $result = $this->db->query($sql);
    $KeywordIDList=array();
    while($x=$result->unbuffered_row()){
        array_push($KeywordIDList,$x->KeywordID);
    }

    $likedegrees=array();
    $len=count($arr);
    for($i=0;$i<$len;$i++){
        array_push($likedegrees,array('Keyword'=>$KeywordIDList[$i],'likedegree'=>$arr[$i]));
    }


    foreach ($likedegrees as $key => $row)
    {
        $Keyword[$key]  = $row['Keyword'];
        $likedegree[$key] = $row['likedegree'];
    }
    array_multisort($likedegree, SORT_DESC,$likedegrees);

    $KeywordsArr=array();
    foreach ($likedegrees as $simone){
        array_push($KeywordsArr,$simone['Keyword']);
    }
    return $KeywordsArr;
}


public function HisMostKeywords($hisid){//返回一个人最喜欢的110个Keyword，10+30+50+30
    $sql="SELECT Level0,Level1,Level2,Leveliso FROM user WHERE id={$hisid}";
    $result = $this->db->query($sql);
    $x=$result->row_array();
    $str0=$x['Level0'];
    $str1=$x['Level1'];
    $str2=$x['Level2'];
    $striso=$x['Leveliso'];
    $TopLikes=array();
    $arr0=$this->StrToArr($str0);
    $arr1=$this->StrToArr($str1);
    $arr2=$this->StrToArr($str2);
    $arriso=$this->StrToArr($striso);
    for($i=0;$i<10;$i++){
        array_push($TopLikes,$arr0[$i]);
    }
    for($i=0;$i<30;$i++){
        array_push($TopLikes,$arr1[$i]);
    }
    for($i=0;$i<50;$i++){
        array_push($TopLikes,$arr2[$i]);
    }
    for($i=0;$i<30;$i++){
        array_push($TopLikes,$arriso[$i]);
    }
    return $TopLikes;
}

public function OneBasicRecom($list) {//$list为一个数组，每个元素为一个二维数组，（'PaperID'=>,'Cite'=>,'Title'=>）
    $sum = 0;
    $listPoint = array(0);//这个数组记录了每个切割点的值，就是记录了数轴上，5,15,30,50,100的值。
    foreach ($list as $key) {
        $sum+=$key['Cite'];//计算出权值的总和
        array_push($listPoint, $sum);//把分割点放到数组中
    }
    $num = rand(0, $sum);//取0到sum之间一个随机值
    for ($i = 0; $i < count($list); $i++)
    {
        if ($num >= $listPoint[$i] && $num < $listPoint[$i+1]) //判断随机值落在哪个范围内
        {
            return $list[$i]; //第i项的值
        }
    }
    return $list[count($list)-1];
}

}
?>