</div>
<?php $this->load->helper('url');?>
<div class="tab-pane fade" id="graph">
<svg width="1080" height="600"></svg>
<style>
.links line {
  stroke: #999;
  stroke-opacity: 0.6;
}

.nodes circle {
  stroke: #fff;
  stroke-width: 1.5px;
}

.node text {
        font: 10px sans-serif;
        }

.link {
        fill: none;
        stroke: #ccc;
        stroke-width: 1.5px;
        }

.d3-tip {
 line-height: 1;
 font-weight: bold;
 padding: 12px;
 background: rgba(0, 0, 0, 0.8);
 color: #fff;
 border-radius: 2px;
}
/* Creates a small triangle extender for the tooltip */
.d3-tip:after {
 box-sizing: border-box;
 display: inline;
 font-size: 10px;
 width: 100%;
 line-height: 1;
 color: rgba(0, 0, 0, 0.8);
 position: absolute;
 text-align: center;
}
/* Style northward tooltips differently */
.d3-tip.n:after {
 margin: -1px 0 0 0;
 top: 100%;
 left: 0;
}

</style>
<script src="<?=base_url()?>js/d3.v4.min.js"></script>
<script src="<?=base_url()?>js/d3-tip.js"></script>
<script>
var authorprefix = "<?=site_url("Search/single_author_page/")?>";
var svg = d3.select("svg"),
    width = +svg.attr("width"),
    height = +svg.attr("height");

var color = d3.scaleOrdinal(d3.schemeCategory20);

var simulation = d3.forceSimulation()
    .force("link", d3.forceLink().id(function(d) { return d.id; }).distance(function(d){ return d.value}))
    .force("charge", d3.forceManyBody())
    .force("center", d3.forceCenter(270,300));

d3.json("<?=site_url("Search/force_directed_graph/")?><?=$inform["Author_ID"]?>", function(error, graph) {
  if (error) throw error;
  var link = svg.append("g")
      .attr("class", "links")
      .selectAll("line")
      .data(graph.links)
      .enter().append("line")
      .attr("stroke-width", function(d) { return Math.sqrt(d.value); });
  
  var node = svg.append("g")
            .attr("class", "nodes")
            .selectAll("circle")
            .data(graph.nodes)
            .enter().append("circle")
            .attr("r", 5)
            .attr("fill", function(d) { return color(d.group); })
      .on("mouseover",function(d,i){
            tip.show(d);
            link.style('stroke-width', function(edge){
                if( edge.source === d || edge.target === d ){
                    return 2*Math.sqrt(edge.value);
                }
            }).style('stroke', function(edge){
                if( edge.source === d || edge.target === d ){
                    return '#000';
                }
            });
        })
      .on("mouseout",function(d,i){
            tip.hide();
            link.style('stroke-width', function(edge){
                if( edge.source === d || edge.target === d ){
                    return Math.sqrt(edge.value);
                }
            }).style('stroke', function(edge){
                if( edge.source === d || edge.target === d ){
                    return '#ddd';
                }
            });
        })
    .on("dblclick",function(d,i){
        window.open(authorprefix+d.id);
    })
      .call(d3.drag()
          .on("start", dragstarted)
          .on("drag", dragged)
          .on("end", dragended));
  var tip = d3.tip()
    .attr('class', 'd3-tip')
    .offset([-10, 0])
    .html(function(d) {
      return "Name:"+d.name+"\nID:"+d.id;
    })
    
  svg.call(tip);

  simulation
      .nodes(graph.nodes)
      .on("tick", ticked);

  simulation.force("link")
      .links(graph.links);
  simulation.restart();

  function ticked() {
    link
        .attr("x1", function(d) { return d.source.x; })
        .attr("y1", function(d) { return d.source.y; })
        .attr("x2", function(d) { return d.target.x; })
        .attr("y2", function(d) { return d.target.y; });

    node
        .attr("cx", function(d) { return d.x; })
        .attr("cy", function(d) { return d.y; });
  }

});

function dragstarted(d) {
  if (!d3.event.active) simulation.alphaTarget(0.3).restart();
  d.fx = d.x;
  d.fy = d.y;
}

function dragged(d) {
  d.fx = d3.event.x;
  d.fy = d3.event.y;
}

function dragended(d) {
  if (!d3.event.active) simulation.alphaTarget(0);
  d.fx = null;
  d.fy = null;
}

///Tree------------------------------------------------------------


var i = 0,
    duration = 750,
    root;

var tree = d3.tree()
    .size([540, 600]);


var stratify = d3.stratify()
  .id(function(d) {
    return d.name;//This position
  })
  .parentId(function(d) {
    return d.parent; //What position this position reports to
  });
d3.json("<?=site_url("Search/student_graph/")?><?=$inform["Author_ID"]?>",function (data) {
var root = stratify(data);

root.each(function(d) {
  
    d.name = d.id; //transferring name to a name variable
    d.id = i; //Assigning numerical Ids
    i++;
  
  });

  root.x0 = 540;
  root.y0 = 300;

  function collapse(d) {
    if (d.children) {
      d._children = d.children;
      d._children.forEach(collapse);
      d.children = null;
    }
  }

  root.children.forEach(collapse);
  update(root);


//d3.select(self.frameElement).style("height", "800px");

function update(source) {

  // Compute the new tree layout.
  var nodes = tree(root).descendants(),
      links = nodes.slice(1);

  // Normalize for fixed-depth.
  nodes.forEach(function(d) { d.y = d.depth * 90+540; });

  // Update the nodes…
  var node = svg.selectAll("g.node")
      .data(nodes, function(d) { return d.id || (d.id = ++i); });

  // Enter any new nodes at the parent's previous position.
  var nodeEnter = node.enter().append("g")
      .attr("class", "node")
      .attr("transform", function(d) { return "translate(" + source.y0 + "," + source.x0 + ")"; })
      .on("click", click);

  nodeEnter.append("circle")
      .attr("r", 1e-6)
      .style("fill", function(d) { return d._children ? "lightsteelblue" : "#fff"; });

  nodeEnter.append("text")
      .attr("x", function(d) { return d.children || d._children ? -10 : 10; })
      .attr("dy", ".35em")
      .attr("text-anchor", function(d) { return d.children || d._children ? "end" : "start"; })
      .text(function(d) { return d.data.title; })
      .style("fill-opacity", 1e-6)
      .on("click",function(d){window.open(authorprefix+d.name)});

  // Transition nodes to their new position.
  var nodeUpdate = node.merge(nodeEnter).transition()
      .duration(duration)
      .attr("transform", function(d) { return "translate(" + d.y + "," + d.x + ")"; });

  nodeUpdate.select("circle")
      .attr("r", 4.5)
      .style("fill", function(d) { return d._children ? "lightsteelblue" : "#fff"; });

  nodeUpdate.select("text")
      .style("fill-opacity", 1);

  // Transition exiting nodes to the parent's new position.
  var nodeExit = node.exit().transition()
      .duration(duration)
      .attr("transform", function(d) { return "translate(" + source.y + "," + source.x + ")"; })
      .remove();

  nodeExit.select("circle")
      .attr("r", 1e-6);

  nodeExit.select("text")
      .style("fill-opacity", 1e-6);


  // Update the links…
  var link = svg.selectAll("path.link")
      .data(links, function(link) { var id = link.id + '->' + link.parent.id; return id; });
  
  // Transition links to their new position.
  link.transition()
      .duration(duration)
      .attr("d", connector);

  // Enter any new links at the parent's previous position.
  var linkEnter = link.enter().insert("path", "g")
                        .attr("class", "link")
                        .attr("d", function(d) {
        var o = {x: source.x0, y: source.y0, parent:{x: source.x0, y: source.y0}};
        return connector(o);
      });

  // Transition links to their new position.
  link.merge(linkEnter).transition()
      .duration(duration)
      .attr("d", connector);

  // Transition exiting nodes to the parent's new position.
  link.exit().transition()
      .duration(duration)
      .attr("d",  function(d) {
        var o = {x: source.x, y: source.y, parent:{x: source.x, y: source.y}};
        return connector(o);
      })
      .remove();

  // Stash the old positions for transition.
  nodes.forEach(function(d) {
    d.x0 = d.x;
    d.y0 = d.y;
  });

// Toggle children on click.
function click(d) {
  if (d.children) {
    d._children = d.children;
    d.children = null;
  } else {
    d.children = d._children;
    d._children = null;
  }
  update(d);
}}});

function connector(d) {
  return "M" + d.y + "," + d.x +
    "C" + (d.y + d.parent.y) / 2 + "," + d.x +
    " " + (d.y + d.parent.y) / 2 + "," + d.parent.x +
    " " + d.parent.y + "," + d.parent.x;
}
</script>
</div>